// Copyright 2008-2018 Yolo Technologies, Inc. All Rights Reserved. https://www.comblockengine.com

#ifndef KBE_MYSQL_DB_RW_CONTEXT_H
#define KBE_MYSQL_DB_RW_CONTEXT_H

#include "common/common.h"
#include "common/memorystream.h"
#include "helper/debug_helper.h"

namespace KBEngine { 
namespace mysql {

/**
	дɾʱõȡдĸϢ

	dbidʵdbidӱǵǰѯdbid

	dbidsdbidsֻһdbidʵidʵݴӱ֣ݽṹһӱʱ
		dbidsӱ, ÿdbidʾӱ϶ӦֵҰ˳ͬʱҲʾжӦλõֵ
		dbids = {
			123 : [xxx, xxx, ...], // 123ΪϵĳdbidΪӱ븸ĵdbids
			...
		}

	itemsֶϢдֶҲжӦҪдֵ

	optableӱṹ

	resultsʱѯ, ݵжӦitemsеstrkeydbids
	readresultIdxΪresultsеdbids * itemsԵĳЩݹʱݻreadresultIdxλá

	parentTableDBIDdbid
	parentTableName

	tableNameǰ
 */
class DBContext
{
public:
	/**
		洢Ҫıitemṹ
	*/
	struct DB_ITEM_DATA
	{
		DB_ITEM_DATA()
		{
			sqlkey = NULL;
		}

		char sqlval[MAX_BUF];
		const char* sqlkey;
		std::string extraDatas;
	};

	typedef std::vector< std::pair< std::string/*tableName*/, KBEShared_ptr< DBContext > > > DB_RW_CONTEXTS;
	typedef std::vector< KBEShared_ptr<DB_ITEM_DATA>  > DB_ITEM_DATAS;

	DBContext()
	{
	}

	~DBContext()
	{
	}
	
	DB_ITEM_DATAS items;
	
	std::string tableName;
	std::string parentTableName;
	
	DBID parentTableDBID;
	DBID dbid;
	
	DB_RW_CONTEXTS optable;
	
	bool isEmpty;
	
	std::map<DBID, std::vector<DBID> > dbids;
	std::map<DBID, std::pair< std::vector<std::string>::size_type, std::vector<std::string> > > results;

private:

};

}
}
#endif // KBE_MYSQL_DB_RW_CONTEXT_H

